<?php

/**
 * Fired during plugin activation
 *
 * @link       orionorigin@orionorigin.com
 * @since      1.0.0
 *
 * @package    Pcd
 * @subpackage Pcd/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Pcd
 * @subpackage Pcd/includes
 * @author     orionorigin <orionorigin@orionorigin.com>
 */
class Pcd_Activator {

    /**
     * Short Description. (use period)
     *
     * Long Description.
     *
     * @since    1.0.0
     */
    public static function activate() {
        global $wp_rewrite;
        add_option('pcd_do_activation_redirect', true);
        $wp_rewrite->flush_rules(false);
    }

}
