(function ($) {
    "use strict";
    $(document).ready(function () {
        $(document).on('touchstart click', '#font-family-selector > div', function () {
            var vpc_get_font_selected = $(this).attr('style').replace('font-family:', '');
            $(this).parent('#font-family-selector').attr('value',vpc_get_font_selected);
            $(this).parent('#font-family-selector').trigger('change');
        });

       
        
        $('ul.pcd-tabs li').click(function(){
            var pcd_tab_id = $(this).attr('data-tab');

            $('ul.pcd-tabs li').removeClass('current');
            $('.pcd-tab-content').removeClass('current');

            $(this).addClass('current');
            $("#"+pcd_tab_id).addClass('current');
	   });
        
        $('ul.wpc-tabs li').click(function(){
            var wpc_tab_id = $(this).attr('data-tab');

            //$('ul.wpc-tabs li').removeClass('current');
            $(this).parents('ul.wpc-tabs').find('li').removeClass('current');
            //$('.wpc-tab-content').removeClass('current');
            $(this).parents('.wpc-tools-content').find('.wpc-tab-content').removeClass('current');

            $(this).addClass('current');
            $("#"+wpc_tab_id).addClass('current');
        });
        
        
        $(document).on('touchstart click', '.wpc-button-bar #align_btn', function () {
            $(".wpc-button-bar .align_btn_wrap").toggleClass('is-open');
        });

        var $first = $('li:first', 'ul#wpc-parts-bar'), $last = $('li:last', 'ul#wpc-parts-bar');
        $first.addClass('first');
        $last.addClass('last');
        var pcd_editor = {};
        pcd_editor.selected_part = -1;
        function wpc_slider_nav(){
            if ($('#wpc-parts-bar li.active').hasClass('first')) {
            $('.pcd-part-prev').hide();
            $('.pcd-part-next').show();
            } else if ($('#wpc-parts-bar li.active').hasClass('last')) {
                $('.pcd-part-next').hide();
                $('.pcd-part-prev').show();
            } else {
                $('.pcd-part-prev').show();
                $('.pcd-part-next').show();
            }
        }
        wpc_slider_nav();
        $(document).on('touchstart click','#product-part-slider > span', function () {
            var $next, $selected = $(".active");
            $next = $selected.next('li').length ? $selected.next('li') : $first;
            $selected.removeClass("active");
            $next.addClass('active');
            var $this =$('#wpc-parts-bar li.active');
            $this.trigger("click");
            wpc_slider_nav();
        });
        $(document).on('touchstart click','#wpc-parts-bar > li', function () {
            wpc_slider_nav();
        });
        function add_text_empty_msg(){
            $("#debug").html("");
            $("#debug").html("<div>"+ pcd.translated_strings.empty_txt_area_msg + "</div>");
        }
        function pcd_hide_debug_box(){
            $('#debug-wrap').removeClass('is-open');
        }
        wp.hooks.addAction('pcd.add_text_empty_msg',add_text_empty_msg );
        wp.hooks.addFilter('pcd.add_not_curved_action_before', pcd_hide_debug_box );
        wp.hooks.addFilter('pcd.add_curved_action_before', pcd_hide_debug_box );

        wp.hooks.addFilter('pcd.add_text_selected', pcd_recup_selected_text);
        function pcd_recup_selected_text(options){
            if(options){
                var pcd_selected_text = options.target.text;
                if(pcd_selected_text){
                    $('.pcd-font-view').html(pcd_selected_text);
                }
                var count = pcd_get_text_nb_line(pcd_selected_text,'\n') + pcd_get_text_nb_line(pcd_selected_text,'|n') + 1;
                if(count > 1){
                    $('#pcd-text-align-row').removeClass('pcd-hide-row');
                }
                else{
                    $('#pcd-text-align-row').addClass('pcd-hide-row');
                }
            } 
           // $('#text-panel').trigger('click');
           $('.wpc-porto-skin .wpc-tools-head').removeClass('is-active');
            $('.wpc-porto-skin .wpc-tools-content').removeClass('is-active'); 
            $('#text-panel').addClass('is-active');
            $('#text-panel').parent().find('.wpc-tools-content').addClass('is-active');
            $('#text-panel').parents('.wpc-editor-col').addClass('is-open');
            get_tools_content_height();
        }
        function pcd_get_text_nb_line(string, substring){
           var n=0;
           var pos=0;

           while(true){
               pos=string.indexOf(substring,pos);
               if(pos!==-1){ n++; pos+=substring.length;}
               else{break;}
           }
           return(n);
        }
        
        $(document).on('click touchstart', '.wpc-tools-head', function () {
            PCD_EDITOR.canvas.discardActiveObject();
            $('.wpc-porto-skin .wpc-tools-head').removeClass('is-active');
            $('.wpc-porto-skin .wpc-tools-content').removeClass('is-active'); 
            $(this).addClass('is-active');
            $(this).parent().find('.wpc-tools-content').addClass('is-active');
            $(this).parents('.wpc-editor-col').addClass('is-open');
            get_tools_content_height();
        });
        
        $(document).on('click touchstart', '.wpc-tools-close', function () {
            $(this).parents('.wpc-tools-content').removeClass('is-active');
            $(this).parents('.wpc-tools-wrap').find('.wpc-tools-head').removeClass('is-active');
            $(this).parents('.wpc-editor-col').removeClass('is-open');
            
        });
        function get_tools_content_height(){
            var porto_header_height = $('#header-wrap').outerHeight();
            var header_height = $('header').outerHeight();
            var wpadminbar = $('#wpadminbar').outerHeight();
            var panel_head = $('.wpc-tools-content.is-active .wpc-panel-head').outerHeight();
            if(wpadminbar != null && wpadminbar != 'undefined'){
                    var wpadminbar2 = wpadminbar ;
                    wpadminbar = wpadminbar + 21;
            }
            else{
                
                wpadminbar = 0;
                var wpadminbar2 = 0;
            }
            if(porto_header_height != null && porto_header_height != 'undefined'){
                porto_header_height = porto_header_height;
            }
            else{
                porto_header_height = header_height;
            }
            
            if(panel_head != null && panel_head != 'undefined'){
                panel_head = panel_head;
            }
            else{
                panel_head = 41;
            }
//            var tools_panel = screen.height - porto_header_height - wpadminbar - 74 ;
//            var tools_panel_content = tools_panel - panel_head - 20;
//           
//            
//            var wpc_container_height = $(window).outerHeight() - porto_header_height - wpadminbar  ;
//            var tools_content_height = wpc_container_height- panel_head ;
//            var canvas_height = $(window).outerHeight() - porto_header_height - wpadminbar  - $('.pcd-responsive-toolbar-box').outerHeight() - $('#product-part-container').outerHeight() - 20;
//            var tools_content_top = porto_header_height + wpadminbar2 ;
//            var windowsize = $(window).width();
                
               var tools_panel = $(window).outerHeight() - porto_header_height - wpadminbar;
               var tools_panel = 540;
                var tools_panel_content = tools_panel - panel_head;
            
                var canvas_height = $(window).outerHeight() - porto_header_height - wpadminbar - $('.pcd-responsive-toolbar-box').outerHeight() - $('#product-part-container').outerHeight() - 20;
                var tools_content_top = porto_header_height + wpadminbar2;
                var windowsize = $(window).width();
//            
//            if (windowsize >= 768) {

               
           
//                $('.wpc-porto-skin .wpc-tab-content-wrapper > div:not(".pcd-group-child-wrap"), #pcd-cliparts-groups-parent-wrapper,#pcd-cliparts-groups-wrapper,#tab-clipart-upload-child,#pcd-team-and-number-wrapper,#wpc-cart-box').css({'height': tools_panel_content});
//                $('#tab-clipart-upload-child').css({'height': tools_panel_content - 30});
//                $('.pcd-group-child-wrap .font-selector-container').css({'height': tools_panel_content - 50});
//                $('#tab-upload #acd-uploaded-img,#tab-social-facebook .img-container,#tab-social-instagram .img-container').css({'height': tools_panel_content - 140});
//                $('.wpc-porto-skin.wpc-container .pcd-tab-content').css({'height': tools_panel,'max-height': tools_panel});
//            }


                $('.wpc-button-bar-wrap').css({'height': tools_panel, 'max-height': tools_panel});
                $('.wpc-porto-skin .wpc-tools-content').css({'height': tools_panel, 'max-height': tools_panel, 'overflow' :'hidden'});

            
                var text_scroll_wrap = $('#text-panel-content');
                var text_scroll_height = tools_panel - text_scroll_wrap.find('.wpc-panel-head').outerHeight(); 
                text_scroll_wrap.find('.pcd-tools-content-scroll-wrap').css({'max-height': text_scroll_height});
                
                var clipart_scroll_wrap = $('#cliparts-panel-content');
                var clipart_scroll_height = tools_panel - clipart_scroll_wrap.find('#pcd-clipart-group-container .wpc-panel-head').outerHeight();
                clipart_scroll_wrap.find('#pcd-cliparts-groups-wrapper.pcd-tools-content-scroll-wrap').css({'max-height': clipart_scroll_height});
            
                var clipart_upload_scroll_height = tools_panel - clipart_scroll_wrap.find('#cliparts-panel-content-child .wpc-panel-head').outerHeight();
                clipart_scroll_wrap.find('#tab-clipart-upload-child.pcd-tools-content-scroll-wrap').css({'max-height': clipart_upload_scroll_height});
            
                var image_filters_wrap = $('#pcd-filters-tools-wrap');
                var image_filters_scroll_height = tools_panel - image_filters_wrap.find('#pcd-uploads-filters-wrap .wpc-panel-head').outerHeight();
                image_filters_wrap.find('#pcd-uploads-filters-wrap .pcd-tools-content-scroll-wrap').css({'max-height': image_filters_scroll_height});
            
                var cart_scroll_wrap = $('#add-cart-panel-content');
                var cart_scroll_height= tools_panel - cart_scroll_wrap.find('.wpc-panel-head').outerHeight() - cart_scroll_wrap.find('#add-to-cart-btn').outerHeight() - 10;
                cart_scroll_wrap.find('.pcd-tools-content-scroll-wrap').css({'max-height': cart_scroll_height});
            
                var design_scroll_wrap = $('#user-designs-panel-content');
                var design_scroll_height = tools_panel - design_scroll_wrap.find('.wpc-panel-head').outerHeight();
                design_scroll_wrap.find('.pcd-tools-content-scroll-wrap').css({'max-height': design_scroll_height});
            
                var design_content_scroll_height = tools_panel - design_scroll_wrap.find('.wpc-panel-head').outerHeight() - design_scroll_wrap.find('.wpd-child-wrap-close').outerHeight() - 60;
                design_scroll_wrap.find('.wpd-my-design-preview.wpd-tools-content-scroll-wrap').css({'max-height': design_content_scroll_height});
            
                var upload_scroll_wrap = $('#uploads-panel-content');
                var upload_scroll_height= tools_panel - upload_scroll_wrap.find('.wpc-panel-head').outerHeight() - upload_scroll_wrap.find('#userfile_upload_form').outerHeight();
                upload_scroll_wrap.find('#tab-upload .pcd-tools-content-scroll-wrap').css({'max-height': upload_scroll_height});
            
                var layout_scroll_wrap = $('#layout-panel-content');
                var layout_scroll_height = tools_panel - layout_scroll_wrap.find('.wpc-panel-head').outerHeight(); 
                layout_scroll_wrap.find('.pcd-tools-content-scroll-wrap').css({'max-height': layout_scroll_height});
//                var upload_social_scroll_height = tools_panel - upload_scroll_wrap.find('.wpc-panel-head').outerHeight() - upload_scroll_wrap.find('.wpc-rs-app').outerHeight();
//                upload_scroll_wrap.find('#tab-social-facebook .pcd-tools-content-scroll-wrap,#tab-social-instagram .pcd-tools-content-scroll-wrap').css({'max-height': upload_social_scroll_height});
            
            





















        }

//        $(".wpc-porto-skin #add-cart-content.is-open > div").mCustomScrollbar({
//            axis: "y",
//            theme: "minimal-dark",
//            scrollInertia: 300,
//            advanced: {
//                autoScrollOnFocus: false,
//                updateOnContentResize: true
//            }
//        });
        $( window ).resize(function() {
            get_tools_content_height();
        });
        $(window).load(function () {
            $('.wpc-porto-skin .wpc-tools-head').removeClass('is-active');
            $('.wpc-porto-skin .wpc-tools-content').removeClass('is-active'); 
            $('.wpc-tools-wrap:first-child .wpc-tools-head').addClass('is-active');
            $('.wpc-tools-wrap:first-child .wpc-tools-head').parent().find('.wpc-tools-content').addClass('is-active');
            $('.wpc-tools-wrap:first-child .wpc-tools-head').parents('.wpc-editor-col').addClass('is-open');
            
            get_tools_content_height();
            var windowsize = $(window).width();
            if (windowsize >= 768) {
               // alert('toto');
                
                // $(".wpc-porto-skin .wpc-tools-content > div:last-child,.wpc-porto-skin.wpc-container .pcd-tab-content").mCustomScrollbar({
                // axis: "y",
                // theme: "minimal-dark",
                // scrollInertia: 300,
                // advanced: {
                //     autoScrollOnFocus: false,
                //     updateOnContentResize: true
                // }
                // });

                // $(".wpc-porto-skin .wpc-tools-content > div:not('.pcd-uploads-editing-wrap,#debug-wrap'):last-child,.wpc-porto-skin.wpc-container .pcd-tab-content").mCustomScrollbar({
                // axis: "y",
                // theme: "minimal-dark",
                // scrollInertia: 300,
                // advanced: {
                //     autoScrollOnFocus: false,
                //     updateOnContentResize: true
                // }
                // });

//                $('.pcd-team-name-and-number-row-contianer,.wpc-porto-skin .wpc-tab-content-wrapper > div:not(".pcd-group-child-wrap"),#pcd-cliparts-groups-parent-wrapper,#pcd-cliparts-groups-wrapper,#tab-clipart-upload-child,#pcd-team-and-number-wrapper,#wpc-cart-box,#tab-clipart-upload-child,.pcd-group-child-wrap .font-selector-container,#tab-upload #acd-uploaded-img,#tab-social-facebook .img-container,#tab-social-instagram .img-container,.wpc-porto-skin.wpc-container .pcd-tab-content').mCustomScrollbar({
//                axis: "y",
//                theme: "minimal-dark",
//                scrollInertia: 300,
//                advanced: {
//                    autoScrollOnFocus: false,
//                    updateOnContentResize: true
//                }
//                });  
                
                
                 $(".wpc-porto-skin .pcd-tools-content-scroll-wrap").mCustomScrollbar({
                 axis: "y",
                 theme: "minimal-dark",
                 scrollInertia: 300,
                 advanced: {
                     autoScrollOnFocus: false,
                     updateOnContentResize: true
                 }
                 });
                
                
            }
            
            $('#debug').bind('DOMNodeInserted', function(e){
                $(this).parents('#debug-wrap').addClass('is-open');
                if($('#debug').is(':empty')){
                $(this).parents('#debug-wrap').removeClass('is-open');
                }
                else{
                   
                    $(this).parents('#debug-wrap').addClass('is-open');
                }
            });
            
            $(document).on('click touchstart', '#debug-wrap.is-open .debug-icon', function () {
                $(this).parents('#debug-wrap').removeClass('is-open');
            });
//            $(document).on('click touchstart', '#add-cart-wrap .cart-icon', function () {
//                $('#debug-wrap.is-open .debug-icon').trigger("click");
//                $(this).parents('#add-cart-wrap').find('#add-cart-content').toggleClass('is-open');
//            });
            
            function pcd_get_greek_state(){
                if ($('#cb-greek').is(':checked')){
                    
                    $('.pcd-greek-character-wrap').addClass('is-active');
                }
                else{
                    
                     $('.pcd-greek-character-wrap').removeClass('is-active');
                }
            }
            pcd_get_greek_state();
            
            $(document).on('change', '#cb-greek', function (){
                pcd_get_greek_state();
            }); 
           
            wp.hooks.addAction('PCD_EDITOR.after_adding_text_on_canvas', pcd_active_added_text);
            function pcd_active_added_text(text,pcd_canvas){
                pcd_canvas.setActiveObject(text);
            }
            
            $(document).on('touchstart click', '.pcd-number-input button.minus', function () {
                var recup_val = $(this).parent('.pcd-number-input').find("input[type=number]").val();
                var recup_min = $(this).parent('.pcd-number-input').find("input[type=number]").attr('min');
                var recup_step = $(this).parent('.pcd-number-input').find("input[type=number]").attr('step');
                var recup_opacity = $(this).parent('.pcd-number-input').find("input[type=number]").data('opacity');
                if(recup_opacity !== true){
                    var new_val= parseInt(recup_val) - parseInt(recup_step);
                }
                else{
                   var new_val= (parseFloat(recup_val) - parseFloat(recup_step)).toFixed(1); 
                   var recup_min =0.0;
                }
                if(new_val >= recup_min){
                    if(recup_opacity === true && new_val == recup_min){
                       var new_val= 0; 
                    }
                    $(this).parent('.pcd-number-input').find("input[type=number]").val(new_val);
                }
                $(this).parent('.pcd-number-input').find("input[type=number]").trigger('change');
                //console.log($(this).parent('.pcd-number-input').find("input[type=number]"));
            });
        
            $(document).on('touchstart click', '.pcd-number-input button.plus', function () {
                var recup_val = $(this).parent('.pcd-number-input').find("input[type=number]").val();
                var recup_max = $(this).parent('.pcd-number-input').find("input[type=number]").attr('max');
                var recup_step = $(this).parent('.pcd-number-input').find("input[type=number]").attr('step');
                var recup_opacity = $(this).parent('.pcd-number-input').find("input[type=number]").data('opacity');
                if(recup_opacity !== true){
                    var new_val= parseInt(recup_val) + parseInt(recup_step);
                }
                else{
                    var new_val= (parseFloat(recup_val) + parseFloat(recup_step)).toFixed(1); 
                    var recup_max =1.0;
                }
                if(new_val <= recup_max){
                    if(recup_opacity === true && new_val == recup_max){
                       var new_val= 1; 
                    }
                    $(this).parent('.pcd-number-input').find("input[type=number]").val(new_val);
                }
                $(this).parent('.pcd-number-input').find('input[type=number]').trigger('change');
            });

            $(document).on('touchstart click', '.pcd-font-group-wrap .pcd-font-group', function () {
                $(this).parents('.wpc-tab-content-wrapper').find('.pcd-group-child-wrap').addClass('is-open');
            });
//            $(document).on('touchstart click', '#tab-saved-design .pcd_order_item', function () {
//                $(this).parents('.wpc-tab-content-wrapper').find('.pcd-group-child-wrap').addClass('is-open');
//            });
	    $(document).on('touchstart click', '#tab-saved-design .pcd_order_item', function () {
                var variation_id = $(this).attr("data-item");
                var save_time = $(this).attr("data-save-time");
                var open = $(this).parents('.wpc-tab-content-wrapper').find('.pcd-group-child-wrap[data-variation-id = "' + variation_id + '"][data-save-time = "' + save_time + '"]');
		open.addClass('is-open');
            });
            $(document).on('touchstart click', '.pcd-cliparts-groups-parent > li,#pcd-search-cliparts-group-parent-results > li', function () {
                var group_parent_id = $(this).data("group-parent-id");
                var group_parent_name= $(this).html();
                $('#pcd-clipart-group-parent-selected').html(group_parent_name);
                $(this).parents('.wpc-tools-content').find('.pcd-group-parent-child-wrap').addClass('is-open');

            });
            $(document).on('touchstart click', '.pcd-child-wrap-close', function () {
                $(this).parents('.pcd-group-child-wrap').removeClass('is-open');
            });
            $(document).on('touchstart click', '.pcd-parent-wrap-close', function () {
                $(this).parents('.pcd-group-parent-child-wrap').removeClass('is-open');
            });
//            $(document).on('touchstart click', '.pcd-clipart-edit-close', function () {
//                $(this).parents('#pcd-cliparts-filters-wrap').removeClass('is-open');
//            });
//            $(document).on('touchstart click', '.pcd-upload-edit-close', function () {
//                $(this).parents('#pcd-uploads-filters-wrap').removeClass('is-open');
//            });
            wp.hooks.addAction('PCD_EDITOR.object_deselected', pcd_object_deselected);
            function pcd_object_deselected(options,image_type){
                var pcd_object_type= options.target.type;

                $('#pcd-text-align-row').addClass('pcd-hide-row');
                $('#copy_paste_btn,#align_btn,#delete_btn').addClass('pcd_btn_hidden');
                $('.wpc-button-bar .align_btn_wrap').removeClass("is-open");

                if(pcd_object_type == "i-text" || (pcd_object_type == "group") && options.target.get("originalText") ){
                    $('.pcd-font-view').html('Hello');
                }
                if(pcd_object_type == "path-group" || pcd_object_type == "image"){
                    $('#pcd-filters-tools-wrap').removeClass('is-active');
                }
                if (image_type === "cliparts-panel") {
                    $('#pcd-cliparts-filters-wrap').removeClass('is-open');
                }
                else if(image_type === "uploads-panel"){
                    $('#pcd-uploads-filters-wrap').removeClass('is-open');
                }
                
            }
            wp.hooks.addAction('PCD_EDITOR.image_selected', pcd_open_clipart_editor);
            function pcd_open_clipart_editor (target, image_type){
                
                $('#pcd-filters-tools-wrap').addClass('is-active');
                $('#pcd-uploads-filters-wrap').addClass('is-open');
                
//                if(image_type === "cliparts-panel"){
//                    $('.wpc-tools-head,.wpc-tools-content').removeClass('is-active');
//                    $('#cliparts-panel').addClass('is-active');
//                    $('#cliparts-panel-content').addClass('is-active');
//                    $('.pcd-group-parent-child-wrap,.pcd-group-child-wrap').removeClass('is-open');
//                    $('#pcd-cliparts-filters-wrap').addClass('is-open');
//                }
//                else if(image_type === "uploads-panel"){
//                    $('.wpc-tools-head,.wpc-tools-content').removeClass('is-active');
//                    $('#uploads-panel').addClass('is-active');
//                    $('#uploads-panel-content').addClass('is-active');
//                    
//                    $('#pcd-uploads-filters-wrap').addClass('is-open');
//                }
            }
            wp.hooks.addAction('PCD_EDITOR.object_selected', pcd_any_object_selected);
            function pcd_any_object_selected(options){
                $(".wpc-button-bar > .pcd_btn_hidden").removeClass('pcd_btn_hidden');
            }
            function pcd_get_team_name_tools(){

                if ($('#cb-add-name').is(':checked')){
                    console.log("toto");
                    $('.pcd-team-name-wrap #cb-add-name').parents('.pcd-team-name-wrap').find('.pcd-team-tools').addClass('is-active');
                }
                else{
                    
                     $('.pcd-team-name-wrap #cb-add-name').parents('.pcd-team-name-wrap').find('.pcd-team-tools').removeClass('is-active');
                }
            }
            function pcd_get_team_number_tools(){
                if ($('.pcd-team-number-wrap #cb-add-number').is(':checked')){
                    
                    $('.pcd-team-number-wrap #cb-add-number').parents('.pcd-team-number-wrap').find('.pcd-team-tools').addClass('is-active');
                }
                else{
                    
                     $('.pcd-team-number-wrap #cb-add-number').parents('.pcd-team-number-wrap').find('.pcd-team-tools').removeClass('is-active');
                }
            }
            $('#cb-add-name').change(function (){
                 pcd_get_team_name_tools();
            
            });
            $('#cb-add-number').change(function (){
                pcd_get_team_number_tools();
            
            });
            pcd_get_team_name_tools();
            pcd_get_team_number_tools();

            $(document).on('touchstart click', '#pcd-add-team-info,.pcd-greek-character-wrap > div,.wpc-facebook.acd-social-login,.wpc-instagram.acd-social-login', function () {
                alert("Not yet implemented");
                return false;
            });
            
            $('.pcd-add-team-row').click(function(){
                var lastRepeatingGroup = $('.pcd-team-row').last();
                lastRepeatingGroup.clone().insertAfter(lastRepeatingGroup);
                return false;
            });
            
            
      });  
           
    });
    
})(jQuery);

